#include <sourcemod>
#include <sdktools>
#include <multicolors>
#include <autoexecconfig>
#include <adminmenu>

#pragma semicolon 1

#define DEBUG

#pragma newdecls required

char g_ChatPrefix[256];
ConVar gConVar_Chat_Prefix;

//BHOP ROUND FOR STAFF
ConVar gConVar_ForceStartMessage;
ConVar gConVar_ForceStopMessage;
ConVar gConVar_FinishRoundMessage;

bool BhopRound = false;

//ADMIN MENU

Handle hAdminMenu;

public Plugin myinfo = 
{
	name = "Bhop Round", 
	author = "LanteJoula", 
	description = "Bhop Round", 
	version = "1.1", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

public void OnPluginStart()
{
	LoadTranslations("bhopround.phrases");
	
	HookEvent("round_end", OnRoundEndX);
	
	RegAdminCmd("sm_bhopround", CMD_BHOP, ADMFLAG_GENERIC, "Open Menu for Bhop Round");
	RegAdminCmd("sm_br", CMD_BHOP, ADMFLAG_GENERIC, "Open Menu for Bhop Round");
	RegAdminCmd("sm_bhop", CMD_BHOP, ADMFLAG_GENERIC, "Open Menu for Bhop Round");
	
	AutoExecConfig_SetFile("plugin.bhopround");
	
	//PREFIX
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("sm_bhopround_chat_prefix", "[{green}TAG{default}]", "Chat Prefix");
	
	//BHOP ROUND FOR STAFF
	gConVar_ForceStartMessage = AutoExecConfig_CreateConVar("sm_bhopround_forcestart_message", "1", "Enable/Disable the Message on BHOP Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_ForceStopMessage = AutoExecConfig_CreateConVar("sm_bhopround_forcestop_message", "1", "Enable/Disable the Message when Staff Force Stop the Bhop Round (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_FinishRoundMessage = AutoExecConfig_CreateConVar("sm_bhopround_finishround_message", "1", "Enable/Disable the Message when Round End (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	gConVar_Chat_Prefix.AddChangeHook(OnPrefixChange);
	
	//DISABLE CONVARS ON CHAT
	HookEvent("server_cvar", SilentEvent, EventHookMode_Pre);
	
	//RegPluginLibrary
	RegPluginLibrary("bhopround");
}

////////
//Prefix
////////

public void SavePrefix()
{
	GetConVarString(gConVar_Chat_Prefix, g_ChatPrefix, sizeof(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

/////////////////////////
//DISABLE CONVARS ON CHAT
/////////////////////////

public Action SilentEvent(Event event, const char[] name, bool dontBroadcast)
{
	SetEventBroadcast(event, true);
	return Plugin_Continue;
}

//////
//MENU
//////

public Action CMD_BHOP(int client, int args)
{
	ShowMenu(client);
}

void ShowMenu(int client)
{
	char StartVote1[128];
	char PreStartMenu1[128];
	char ForceStopMenu1[128];
	
	Menu menu = new Menu(Menu_Handler);
	menu.SetTitle("%t\n ", "Bhop Round Title");
	
	Format(StartVote1, sizeof(StartVote1), "%t", "StartVote");
	menu.AddItem("1", StartVote1);
	
	if (!BhopRound)
	{
		Format(PreStartMenu1, sizeof(PreStartMenu1), "%t", "PreStartMenu");
		menu.AddItem("2", PreStartMenu1);
	}
	else
	{
		Format(ForceStopMenu1, sizeof(ForceStopMenu1), "%t", "ForceStopMenu");
		menu.AddItem("3", ForceStopMenu1);
	}
	menu.ExitButton = true;
	menu.Display(client, MENU_TIME_FOREVER);
}

public int Menu_Handler(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		if (StrEqual(selectedItem, "1"))
		{
			FakeClientCommand(client, "sm_vote \"%t\"", "BhopRoundVote");
		}
		if (StrEqual(selectedItem, "2"))
		{
			BhopRound = true;
			
			SetCvar("sv_enablebunnyhopping", "1");
			SetCvar("sv_autobunnyhopping", "1");
			SetCvar("sv_staminamax", "0");
			SetCvar("sv_airaccelerate", "500");
			SetCvar("sv_staminajumpcost", "0");
			SetCvar("sv_staminalandcost", "0");
			
			if (gConVar_ForceStartMessage.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "Bhop Round Force Start");
		}
		if (StrEqual(selectedItem, "3"))
		{
			BhopRound = false;
			
			SetDefaultValue("sv_enablebunnyhopping");
			SetDefaultValue("sv_autobunnyhopping");
			SetDefaultValue("sv_staminamax");
			SetDefaultValue("sv_airaccelerate");
			SetDefaultValue("sv_staminajumpcost");
			SetDefaultValue("sv_staminalandcost");
			
			char name[128];
			GetClientName(client, name, sizeof(name));
			
			if (gConVar_ForceStopMessage.BoolValue)
				CPrintToChatAll("%s %t", g_ChatPrefix, "Bhop Round Force Stop", name);
		}
	}
	else if (action == MenuAction_End)
	{
		delete menu;
	}
}


public Action OnRoundEndX(Event event, const char[] name, bool dontBroadcast)
{
	if (BhopRound)
	{
		BhopRound = false;
		
		SetDefaultValue("sv_enablebunnyhopping");
		SetDefaultValue("sv_autobunnyhopping");
		SetDefaultValue("sv_staminamax");
		SetDefaultValue("sv_airaccelerate");
		SetDefaultValue("sv_staminajumpcost");
		SetDefaultValue("sv_staminalandcost");
		
		if (gConVar_FinishRoundMessage.BoolValue)
			CPrintToChatAll("%s %t", g_ChatPrefix, "Finish Bhop Round");
	}
}

//SETCVAR AND SETDEFAULTVALUE

stock void SetCvar(const char[] scvar, const char[] svalue)
{
	ConVar cvar = FindConVar(scvar);
	if (cvar == INVALID_HANDLE)
		return;
	
	SetConVarString(cvar, svalue, true);
}

stock void SetDefaultValue(char[] scvar)
{
	ConVar cvar = FindConVar(scvar);
	if (cvar == INVALID_HANDLE)
		return;
	
	char szDefault[100];
	cvar.GetDefault(szDefault, sizeof(szDefault));
	
	SetConVarString(cvar, szDefault, true);
}

////////////
//ADMIN MENU
////////////

public void OnAllPluginsLoaded()
{
	if (!LibraryExists("especialrounds")) //WITH ESPECIALS ROUNDS
	{
		Handle topmenu;
		if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != null))
			OnAdminMenuReady(topmenu);
	}
}

public void OnAdminMenuReady(Handle topmenu)
{
	if (topmenu == hAdminMenu)
		return;
	
	hAdminMenu = topmenu;
	CreateTimer(1.0, Timer_AttachAdminMenu);
}

public Action Timer_AttachAdminMenu(Handle timer)
{
	TopMenuObject menu_category = AddToTopMenu(hAdminMenu, "bhopround", TopMenuObject_Category, Handle_Category, INVALID_TOPMENUOBJECT, "bhopround", ADMFLAG_GENERIC);
	if (menu_category == INVALID_TOPMENUOBJECT)
		return;
	
	AddToTopMenu(hAdminMenu, "sm_bhopround", TopMenuObject_Item, AdminMenu_BhopRound, menu_category, "sm_bhopround", ADMFLAG_GENERIC);
}

public void Handle_Category(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayTitle)
		Format(buffer, maxlength, "%T", "Bhop Round Title in Admin", param);
	else if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "Bhop Round Title in Admin", param);
}

public void AdminMenu_BhopRound(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "Bhop Round Buttom in Admin", param);
	else if (action == TopMenuAction_SelectOption)
		ShowMenu(param);
} 